<!--- AddressBook.cfc --->
<cfcomponent>
   

   <!--- used to check if a user is logged in.  
         Notice that there is no roles restriction on this function. --->
   <cffunction 
      name="verifyLogin" 
      returnType="numeric" 
      access="remote" 
      output="false">
      
      <cfset var auth = 0>

      <cfif isUserInRole("AuthorizedUser")>
         <cfset auth = -1>
      </cfif>

      <cfreturn auth>
   </cffunction>

   
   <cffunction
      name="retrievePeople"
      returnType="query"
      access="remote"
      output="false"
      roles="AuthorizedUser">

      <cfset var q = "">

      <cfquery name="q" datasource="#request.ds#">
         
         SELECT 
            PersonID,
            FirstName,
            LastName,
            Phone,
            Email
         FROM
            People
         ORDER BY
            LastName,
            FirstName
      </cfquery>

      <cfreturn q>
   
   </cffunction>
   
   <cffunction
      name="savePerson"
      returnType="void"
      access="remote"
      output="false"
      roles="AuthorizedUser">

      <cfargument name="PersonID" type="string" required="true">
      <cfargument name="FirstName" type="string" required="true">
      <cfargument name="LastName" type="string" required="true">
      <cfargument name="Phone" type="string" required="true">
      <cfargument name="Email" type="string" required="true">

      <cfquery datasource="#request.ds#">

         UPDATE 
            People
         SET
            FirstName = <cfqueryparam value="#arguments.FirstName#" cfsqltype="CF_SQL_VARCHAR">,
            LastName = <cfqueryparam value="#arguments.LastName#" cfsqltype="CF_SQL_VARCHAR">,
            Phone = <cfqueryparam value="#arguments.Phone#" cfsqltype="CF_SQL_VARCHAR">,
            Email = <cfqueryparam value="#arguments.Email#" cfsqltype="CF_SQL_VARCHAR">
         WHERE
            PersonID = <cfqueryparam value="#arguments.PersonID#" cfsqltype="CF_SQL_INTEGER">

      </cfquery>

   </cffunction>

</cfcomponent>

