
ControllerClass = function() {
   model.addListener(this);
}

ControllerClass.prototype.backgroundDepth_num = 1;
ControllerClass.prototype.loginDepth_num = 2;
ControllerClass.prototype.listDepth_num = 3;
ControllerClass.prototype.detailDepth_num = 4;
ControllerClass.prototype.errorDepth_num = 5;

ControllerClass.prototype.start = function() {
   
   view.attachMovie("BackgroundSymbol", "background_mc", this.backgroundDepth_num);

   this.showLogin();
}

ControllerClass.prototype.showLogin = function() {
   
   this.hideAll();

   if (view.login_mc==undefined) {
      view.attachMovie("LoginScreenSymbol", "login_mc", this.loginDepth_num, {_x: 20, _y: 20, _xscale: 200, _yscale: 200});
   } else {
      view.login_mc._visible = true;
   }
}

ControllerClass.prototype.showList = function() {
   
   this.hideAll();

   if (view.list_mc==undefined) {
      view.attachMovie("ListScreenSymbol", "list_mc", this.listDepth_num, {_x: 20, _y: 20, _xscale: 200, _yscale: 200});
   } else {
      view.list_mc._visible = true;
      view.list_mc.clearSelection();
   }
}

ControllerClass.prototype.showDetail = function(person_obj) {
   
   this.hideAll();

   if (view.detail_mc==undefined) {
      view.attachMovie("DetailScreenSymbol", "detail_mc", this.detailDepth_num, {person_obj: person_obj, _x: 20, _y: 20, _xscale: 200, _yscale: 200});
   } else {
      view.detail_mc._visible = true;
      view.detail_mc.setPerson(person_obj);
   }

}

ControllerClass.prototype.showError = function(error_str, backFunc_str) {
   
   this.hideAll();

   if (view.error_mc==undefined) {
      view.attachMovie("ErrorScreenSymbol", "error_mc", this.errorDepth_num, {error_str: error_str, _x: 20, _y: 20, _xscale: 200, _yscale: 200});
   } else {
      view.error_mc._visible = true;
      view.error_mc.setError(error_str);
   }
   this.errorBackFunc_str = backFunc_str;
}

ControllerClass.prototype.hideAll = function() {
   view.login_mc._visible = false;
   view.list_mc._visible = false;
   view.detail_mc._visible = false;
   view.error_mc._visible = false;
}

ControllerClass.prototype.login = function(userName_str, password_str) {
   model.login(userName_str, password_str);
}


ControllerClass.prototype.save = function(person_obj) {
   model.save(person_obj);
}

ControllerClass.prototype.onLoginSuccess = function() {
   
   view.login_mc.removeMovieClip();
   delete view.login_mc;

   this.showList();
   model.retrievePeople();
}

ControllerClass.prototype.onLoginFail = function() {
   this.showError("Login failed", "showLogin");
}

ControllerClass.prototype.errorBack = function() {
   this[this.errorBackFunc_str]();
   delete this.errorBackFunc_str;
}

