_global.DetailScreen = function() {
   
   model.addListener(this);

   this.setPerson(this.person_obj);

}

DetailScreen.prototype = new MovieClip();

DetailScreen.prototype.setPerson = function(person_obj) {
   
   //
   // If we're returning from an error screen, then person_obj will be undefined,
   // so we only populate fields when an obj is provided
   //

   if (person_obj != undefined) {
      this.firstName_txt.text = person_obj["FirstName"];
      this.lastName_txt.text = person_obj["LastName"];
      this.phone_txt.text = person_obj["Phone"];
      this.email_txt.text = person_obj["Email"];
      
      this.person_obj = person_obj;
   }
}

DetailScreen.prototype.setStateView = function() {
   
   this.action_pb.setLabel("Edit");
   this.action_pb.setClickHandler("editClick");

   this.back_pb.setLabel("Back");
   this.back_pb.setClickHandler("backClick");

   this.setTextType("dynamic");

   Selection.setFocus(this.back_pb);

}

DetailScreen.prototype.setStateEdit = function() {
   
   this.action_pb.setLabel("Save");
   this.action_pb.setClickHandler("saveClick");

   this.back_pb.setLabel("Cancel");
   this.back_pb.setClickHandler("cancelClick");
         
   this.setTextType("input");

   Selection.setFocus(this.firstName_txt);

}

DetailScreen.prototype.setTextType = function(textType_str) {
   
   this.firstName_txt.type = textType_str;
   this.lastName_txt.type = textType_str;
   this.phone_txt.type = textType_str;
   this.email_txt.type = textType_str;
   
   // make selectable (clickable) if input
   var b = (textType_str == "input");
   this.firstName_txt.selectable = b;
   this.lastName_txt.selectable = b;
   this.phone_txt.selectable = b;
   this.email_txt.selectable = b;


}

DetailScreen.prototype.editClick = function() {
   this.setStateEdit();
}

DetailScreen.prototype.saveClick = function() {
   
   //
   // Start by validating the data
   //
   if (this.firstName_txt.text.length==0) {
      controller.showError("First Name is required.", "showDetail");
      return;
   }

   if (this.lastName_txt.text.length==0) {
      controller.showError("Last Name is required.", "showDetail");
      return;
   }

   if (this.phone_txt.text.length==0) {
      controller.showError("Phone is required.", "showDetail");
      return;
   }
   
   // validate phone is numbers, dash, space, parenthesis only
   var s = this.phone_txt.text;
   var i = s.length;
   while (i--) {
      switch (s.charAt(i)) {
         case '0':
         case '1':
         case '2':
         case '3':
         case '4':
         case '5':
         case '6':
         case '7':
         case '8':
         case '9':
         case '(':
         case ')':
         case '-':
         case ' ':
            // ok, continue with loop
            break;
         default:
            controller.showError("Phone can only contain numbers and punctuation.", "showDetail");
            return;
      }
   }

   if (this.email_txt.text.length==0) {
      controller.showError("E-Mail is required.", "showDetail");
      return;
   }
   
   // validate that e-mail has an @ in it, just simple validation
   if (this.email_txt.text.indexOf("@") == -1) {
      controller.showError("'" + this.email_txt.text + "' is not a valid e-mail address.", "showDetail");
      return;
   }

   var p = this.person_obj;

   p["FirstName"] = this.firstName_txt.text;
   p["LastName"] = this.lastName_txt.text;
   p["Phone"] = this.phone_txt.text;
   p["Email"] = this.email_txt.text;

   controller.save(p);

   this.setStateView();
}

DetailScreen.prototype.cancelClick = function() {
   this.setPerson(this.person_obj);
   Selection.setFocus(this.back_pb);
   this.setStateView();
}

DetailScreen.prototype.backClick = function() {
   controller.showList();
}

Object.registerClass("DetailScreenSymbol", DetailScreen);
