ModelClass = function() {
   EventBroadcaster.initialize(this);

   NetServices.setDefaultGatewayURL("http://127.0.0.1:8500/flashservices/gateway");
   this.gateway_cn = NetServices.createGatewayConnection();

}


ModelClass.prototype;


ModelClass.prototype.login = function(userName_str, password_str) {
   this.gateway_cn.setCredentials(userName_str, password_str);
   this.address_svc = this.gateway_cn.getService("cfug.flashcf.AddressBook", this);
   this.address_svc.verifyLogin();
}


ModelClass.prototype.verifyLogin_Result = function(result) {
   if (result) {
      this.broadcastMessage("onLoginSuccess");
   } else {
      this.broadcastMessage("onLoginFail");
   }
}

ModelClass.prototype.retrievePeople = function() {
   this.address_svc.retrievePeople();
}

ModelClass.prototype.retrievePeople_Result = function(people_rs) {
   this.people_rs = people_rs;
   this.broadcastMessage("onRetrievePeople", people_rs);
}

ModelClass.prototype.save = function(person_obj) {
   
   this.address_svc.savePerson(person_obj);
   

   //
   // Even though we've directly edited the person_obj which is stored
   // by reference in the recordset, the list doesn't get updated
   // until a model changed event is broadcasted.  To trigger the change,
   // loop through the recordset and find the index of the current record,
   // and then replace it.
   //


   // create a local reference for faster access
   var p_rs = this.people_rs;
   var i = p_rs.getLength();
   while (i--) {
      if (p_rs.getItemAt(i) == person_obj) {
         p_rs.replaceItemAt(i, person_obj);
      }
   }
}

