RecordSet.prototype.getItemAt = function(index)
{
	//trace("RecordSet.getItemAt(" + index + ")");

	// It is server associated. See if the index is valid. 
	if ((index < 0) || (index >= this.getLength()))
	{
		//NetServices.trace("RecordSet", "warning", 104, "getItemAt(" + index + ") index out of range");
		return undefined;
	}
	
	if (this.mRecordSetId == null)
	{
		// this is not a server-associated recordset
		//trace("RecordSet.getItemAt not server-associated");
		return this.items[index];
	}

	// let the paging lookahead code have a look at this request.
	// (even if the record is in memory we might still want to request a download of the page)
	this.requestRecord(index);

	var result = this.items[index];
	if (result == 1) return "in progress";
	//trace("RecordSet.getItemAt(" + index + ") returning " + result);
	return result;
}
